SystemOrganization addCategory: #'EMoe-Models'!
SystemOrganization addCategory: #'EMoe-Views'!
SystemOrganization addCategory: #'EMoe-Seaside'!

WASmallFacesComposite subclass: #EMoeSeasideLDView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EMoe-Seaside'!

!EMoeSeasideLDView class methodsFor: 'seaside' stamp: 'tpc 10/27/2008 17:19'!
label
	^ 'Long Division Example'! !

!EMoeSeasideLDView methodsFor: 'initialization' stamp: 'tpc 10/30/2008 15:53'!
addSubpanes
	
	self 
		addSubpane: self createDivisorTextfield;
		addSubpane: self createDividendTextfield;
		addSubpane: self createDataPanel;
		addSubpane: self createDivideButton! !

!EMoeSeasideLDView methodsFor: 'creation' stamp: 'tpc 10/7/2009 16:19'!
createDataPanel

	| pane |
	pane := SFPanel new.
	pane name: 'qdata'; childrenLayout: SFTopBottomChildrenLayout new.
	
	pane addSubpanes: self updateResultsAsFields.
	^ pane! !

!EMoeSeasideLDView methodsFor: 'creation' stamp: 'tpc 10/28/2008 01:26'!
createDivideButton
	| pane panes |
	panes := OrderedCollection with: (self paneNamed: 'divisor') with: (self paneNamed: 'dividend').
	pane := SFButton new.
	pane
		name: 'divide';
		label: 'Divide';
		when: #clicked
			send: #divideButtonPressed
			to: self
 			updatePaneValue: panes
			refresh: (self paneNamed: 'qdata');
		width: 100;
		topMargin: 15;
		leftMargin: 520.
	^pane! !

!EMoeSeasideLDView methodsFor: 'creation' stamp: 'tpc 10/30/2008 15:56'!
createDividendTextfield
	| pane |
	pane := SFTextField readWrite.
	pane
		name: 'dividend';
		label: 'Dividend' translated;
		text: model dividend;
		maxLength: 5;
		size: 5;
		left.
	^pane! !

!EMoeSeasideLDView methodsFor: 'creation' stamp: 'tpc 10/30/2008 15:55'!
createDivisorTextfield
	| pane |
	pane := SFTextField readWrite.
	pane
		name: 'divisor';
		label: 'Divisor' translated;
		text: model divisor;
		maxLength: 5;
		size: 5;
		right.
	^pane! !

!EMoeSeasideLDView methodsFor: 'events' stamp: 'tpc 10/7/2009 16:12'!
divideButtonPressed
	| pane |
	
	model dividend: (self paneNamed: 'dividend') value asInteger divisor: (self paneNamed: 'divisor') value asInteger.
		
	pane := self paneNamed: 'qdata'.
	pane removeSubpanes.
	pane addSubpane: self updateResultsAsFields
! !

!EMoeSeasideLDView methodsFor: 'style-support' stamp: 'tpc 10/28/2008 00:47'!
formStyle
	| writer|
	writer := CSSWriter new.

	writer openRuleFor: CSSElement div ,  'row' asCSSClass.
	writer padding
		top: 10;
		bottom: 0.
	writer clear clearBoth.	
	writer closeCurrentRule.
	
	writer openRuleFor: (CSSElement div , 'row' asCSSClass) ++ (CSSElement span ,  'labelw' asCSSClass).
	writer classification floatLeft.
	writer dimension width: (CSSMeasure inPercentage: 25).
	writer text rightFlush.		
	writer font beBoldCharWeight.
	writer closeCurrentRule.
	
	writer openRuleFor: (CSSElement div  , 'row' asCSSClass) ++ (CSSElement span , 'formw' asCSSClass).
	writer classification floatRight.
	writer dimension width: (CSSMeasure inPercentage: 73).
	writer text leftFlush.
	writer closeCurrentRule.	
	
	^writer library syntax! !

!EMoeSeasideLDView methodsFor: 'initialization' stamp: 'tpc 10/28/2008 00:56'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	model := LongDivisionModel dividend: 10 divisor: 1.
	
	super initialize.

! !

!EMoeSeasideLDView methodsFor: 'rendering' stamp: 'tpc 10/30/2008 15:53'!
renderContentOn: aRenderer
	super renderContentOn: aRenderer.
	aRenderer 
			render: (self paneNamed: 'divisor');
			render: (self paneNamed: 'dividend');
			render: (self paneNamed: 'divide');
			render: (self paneNamed: 'qdata')! !

!EMoeSeasideLDView methodsFor: 'style-support' stamp: 'tpc 10/28/2008 00:47'!
style
	" Answer a String for the receiver's CSS "

	^ String streamContents: [: stream |
		stream nextPutAll: super style;
				nextPutAll: self formStyle 
		]! !

!EMoeSeasideLDView methodsFor: 'seaside' stamp: 'tpc 10/25/2008 23:15'!
title
	^ 'Long Division View'! !

!EMoeSeasideLDView methodsFor: 'as yet unclassified' stamp: 'tpc 10/7/2009 15:49'!
updateResults

	| result thePanes |
	thePanes := OrderedCollection new.
	result := SFTextArea contents:  (LongDivisionAsciiView on: model reduced) printString.
	result label: ''.
	result rowSizeInChar: (model divided size)*3 +3;
		columnSizeInChar: (model divisorString size) + 6 + (model dividendString size) + (model divisorString size) + 1 ;
		font: (CSSFont familyNames: 'monospace' withSize: 12).
	
	thePanes add: result.
	^thePanes
! !

!EMoeSeasideLDView methodsFor: 'as yet unclassified' stamp: 'tpc 10/7/2009 17:33'!
updateResultsAsFields

	| thePanes digit iterations margin tfieldD tfieldU |
	thePanes := OrderedCollection new.
	
	model reduced.
	digit := 1.
	
	margin := digit printString, 'em'.
	tfieldD := SFTextField contents:   (model divided at: digit) printString.
	tfieldD displayBlock; right; leftMargin: margin.
	thePanes add: tfieldD.
	
	iterations := (model quotient size) -1.
	
	iterations timesRepeat: [
		digit := digit + 1.
		margin := digit printString, 'em'.
		tfieldU := SFTextField contents:   (model undivided at: digit) printString.
		tfieldU displayBlock; right; leftMargin: margin.
		thePanes add: tfieldU.
		tfieldD := SFTextField contents:   (model divided at: digit) printString.
		tfieldD displayBlock; right; leftMargin: margin.
		thePanes add: tfieldD.
	].
	
	^thePanes
! !

!OBMethodCategoryFilter methodsFor: '*EMoe' stamp: 'tpc 10/28/2008 11:49'!
displayString: aStringOrText forParent: pNode child: cNode
    | category |
    category := cNode category.
	category isNil ifTrue: [ category := 'as yet unclassified' ].
    (category beginsWith: '*') ifTrue: [
	    ^(category includesSubString: '-overrides') 
	        ifTrue: [aStringOrText asText addAttribute: TextEmphasis italic; addAttribute: TextColor red]	
	        ifFalse: [aStringOrText asText addAttribute: TextEmphasis italic]].

    ^aStringOrText ! !

Object subclass: #LongDivisionModel
	instanceVariableNames: 'fraction quotient divisor divided undivided dividendDigitNumber remainder dividend steps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EMoe-Models'!

!LongDivisionModel class methodsFor: 'class initialization' stamp: 'tpc 10/6/2009 18:00'!
dividend: numInteger divisor: denInteger
	"Divisor is Denominator
	using nomenclature from Fraction class since we are a special case of a fraction"

	^self numerator: numInteger denominator: denInteger! !

!LongDivisionModel class methodsFor: 'class initialization' stamp: 'tpc 10/6/2009 17:55'!
numerator: numInteger denominator: denInteger
	"using nomenclature from Fraction class since we are a special case of a fraction"

	^self new numerator: numInteger denominator: denInteger.
! !

!LongDivisionModel class methodsFor: 'class initialization' stamp: 'tpc 10/6/2009 17:56'!
operand: numInteger devisor: denInteger
	"using nomenclature from Fraction class since we are a special case of a fraction"

	^self numerator: numInteger denominator: denInteger
! !

!LongDivisionModel methodsFor: 'accessing' stamp: 'tpc 10/6/2009 18:01'!
denominator

	^fraction denominator! !

!LongDivisionModel methodsFor: 'accessing' stamp: 'tpc 7/31/2008 21:20'!
divided

	^divided! !

!LongDivisionModel methodsFor: 'accessing' stamp: 'tpc 10/6/2009 18:01'!
dividend
	^ fraction numerator! !

!LongDivisionModel methodsFor: 'accessing' stamp: 'tpc 10/7/2009 12:49'!
dividend: anInteger
	"assignment"

	|  savedDenominator |
	
	savedDenominator := self denominator.
	self numerator: anInteger denominator: savedDenominator.
		
! !

!LongDivisionModel methodsFor: 'accessing' stamp: 'tpc 10/7/2009 12:37'!
dividend: numInteger divisor: denInteger 
	"assignment
	initialize result varibales as string arrays full of spaces and large enough for result strings."
	self numerator: numInteger denominator:  denInteger.
! !

!LongDivisionModel methodsFor: 'accessing' stamp: 'tpc 10/7/2009 12:37'!
dividendString
	^ self denominator printString! !

!LongDivisionModel methodsFor: 'accessing' stamp: 'tpc 10/7/2009 12:37'!
divisor

	^self denominator! !

!LongDivisionModel methodsFor: 'accessing' stamp: 'tpc 10/7/2009 12:37'!
divisor: anInteger
	"assignment"

	| savedNumerator |
	savedNumerator := fraction numerator.
	self numerator: savedNumerator denominator: anInteger.! !

!LongDivisionModel methodsFor: 'accessing' stamp: 'tpc 10/7/2009 12:37'!
divisorString

	^self denominator printString! !

!LongDivisionModel methodsFor: 'as yet unclassified' stamp: 'tpc 10/7/2009 12:37'!
hasValidDividend
	"return true or false for whether the current dividend is valid"
	
	^(self numerator isNil or: [self numerator <= 0]) not! !

!LongDivisionModel methodsFor: 'as yet unclassified' stamp: 'tpc 10/7/2009 12:37'!
hasValidDivisor
	"return true or false for whether the current divisor is valid"
	
	^(self denominator isNil or: [self denominator <= 0]) not! !

!LongDivisionModel methodsFor: 'as yet unclassified' stamp: 'tpc 10/7/2009 12:31'!
hasValidInputs
	"return true or false for whether the current dividend and divisor is valid"
	
	fraction isNil ifTrue: [^nil] ifFalse: [^ self hasValidDivisor and: [self hasValidDividend]].! !

!LongDivisionModel methodsFor: 'initialization' stamp: 'tpc 10/7/2009 15:55'!
initialize
	"initialize the variables"
	| |
	super initialize.
	steps := OrderedCollection new.
	^ self! !

!LongDivisionModel methodsFor: 'accessing' stamp: 'tpc 10/7/2009 12:31'!
numerator
	^ fraction numerator! !

!LongDivisionModel methodsFor: 'initialization' stamp: 'tpc 10/7/2009 12:50'!
numerator: numInteger denominator: denInteger
	"assignment"

	| iterations |
	
	fraction isNil 
		ifTrue: [fraction := Fraction numerator: numInteger denominator: denInteger ] 
		ifFalse: [fraction setNumerator: numInteger denominator: denInteger ].

	iterations := self numerator printString size.

	quotient := OrderedCollection ofSize: iterations.
	remainder := OrderedCollection ofSize: iterations.
	divided := OrderedCollection ofSize: iterations.
	undivided := OrderedCollection ofSize: iterations.

	undivided 
		at: 1
		put: (self numerator printString at: 1) digitValue.
	dividendDigitNumber := 1.
	
	^self! !

!LongDivisionModel methodsFor: 'printing' stamp: 'tpc 10/7/2009 12:32'!
printOn: aStream 
	aStream nextPut: $(.
	self numerator printString printOn: aStream.
	aStream nextPut: $/.
	self denominator printString printOn: aStream.
	aStream nextPut: $)! !

!LongDivisionModel methodsFor: 'accessing' stamp: 'tpc 7/31/2008 21:20'!
quotient

	^quotient! !

!LongDivisionModel methodsFor: 'private' stamp: 'tpc 10/7/2009 12:39'!
reduced
	"bypass steps and just calculate the quotient and remainder
	reduced should really run through all of the steps and populate 
	divided and undivided"

	"quotient := self dividend // self divisor.
	remainder := self dividend \\ self divisor."
	
	self hasValidInputs ifTrue:
	[ dividendDigitNumber <= (self quotient size) ifTrue: [
	( self quotient size - (dividendDigitNumber -1) ) timesRepeat: [self step.].] ].
	^self! !

!LongDivisionModel methodsFor: 'accessing' stamp: 'tpc 8/29/2008 18:03'!
remainder
	^ remainder! !

!LongDivisionModel methodsFor: 'stepping and presenter' stamp: 'tpc 10/7/2009 12:41'!
step
	"solve the long division problem step by step.
	record the result of each step and the step number.
	will act like an accountants calculator with the printout recording each step.
	
	Steps for long division:

	Undivided = 0
	dividend digit# = 1

 	1) Multiply undivided * 10 + dividend digit

 	2) Place currentUndivided under dividend digit#

 	3) Divide currentUndivided by divisor

 	4) Calculate quotient digit and place atop dividend digit#

 	5) Calculate divided = quotient digit * divisor

 	6) Place divided under undivided

 	7) Calculate newUndivided = currentUndivided - currentDivided

 	8) Increment dividend digit#

 	9) Repeat step 1 with new undivided (next step while undivided > divisor)
	
	Save the values as strings storing store right to left starting at digit.
	Treat divided, undivided, dividend, and quotient as 2 dimensional string array.
	How to represent down arrow from dividend???
	See http://www.mathsisfun.com/long_division2.html"

	|  currentUndivided  newUndivided newDivided currentQuotientDigit newRemainder |
	
	currentUndivided := self undivided at: dividendDigitNumber.
	
	currentQuotientDigit := (currentUndivided // (self denominator)).
	quotient at: dividendDigitNumber put: currentQuotientDigit.
	
	newDivided := (currentQuotientDigit * (self denominator)).
	divided at: dividendDigitNumber put: newDivided.
	
	newRemainder := currentUndivided - newDivided.
	remainder at: dividendDigitNumber put: newRemainder.
	
	dividendDigitNumber < (quotient size) ifTrue: [
		"off by 1. dividend size = 2 yet dividendDigitNumber+1 = 3 since quotient =3. Quotient should be 2.
	     same size as dividend."
		newUndivided := (newRemainder * 10) + (self numerator printString at: dividendDigitNumber + 1) digitValue.
		undivided at: dividendDigitNumber + 1 put: newUndivided.
	
		dividendDigitNumber := dividendDigitNumber + 1.].
	
	! !

!LongDivisionModel methodsFor: 'accessing' stamp: 'tpc 7/31/2008 21:21'!
undivided

	^undivided! !

Object subclass: #LongDivisionView
	instanceVariableNames: 'ldModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EMoe-Views'!

LongDivisionView subclass: #LongDivisionAsciiView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EMoe-Views'!

!LongDivisionAsciiView methodsFor: 'printing' stamp: 'tpc 10/6/2009 18:01'!
printOn: aStream
	"print using the classic long division format
	
	          quotient (q1 q2 q3 ... qn)
divisor | operand (o1 o2 o3 ... on)
--------------------
          divided
          undivided
          divided
            undivided
            divided
               undivided
               divided"

	| iterations digit spaces underline |
	
	spaces := ldModel denominator printString size + 3.
	aStream space: spaces.
	ldModel quotient do: [:c | c printOn: aStream.].
	aStream space: 2; nextPut: $R.
	(ldModel remainder last) printOn: aStream.
	aStream cr.
	
	ldModel denominator printOn: aStream. 
	aStream space; nextPut: $| ; space. ldModel numerator printOn: aStream.
	aStream cr.
	
	aStream space: spaces.
	(ldModel divided at: 1) printOn: aStream.
	aStream cr.

	underline := '----' .
	
	digit := 2.
	iterations := (ldModel quotient size) - 1.
	iterations timesRepeat: [
		aStream space: spaces; nextPutAll: underline;  cr.
		
		aStream space: spaces.
		(ldModel undivided at: digit) printOn: aStream.
		aStream cr.

		aStream space: spaces.
		(ldModel divided at: digit) printOn: aStream.
		aStream cr.


		digit := digit + 1.
		].

	aStream space: spaces; nextPutAll: underline;  cr.
	aStream space: spaces.
	(ldModel remainder last) printOn: aStream.
	aStream cr.

	! !

!LongDivisionView class methodsFor: 'class initialization' stamp: 'tpc 7/31/2008 18:14'!
on: aModel

	^self new model: aModel! !

!LongDivisionView methodsFor: 'accessing' stamp: 'tpc 7/31/2008 18:13'!
model: aModel
	"comment stating purpose of message"

	ldModel := aModel! !

WASmallFacesRegistry subclass: #EMoeSeasideRoot
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EMoe-Seaside'!

!EMoeSeasideRoot class methodsFor: 'seaside' stamp: 'tpc 10/23/2008 18:29'!
canBeRoot
   "Flags the component to show up as a root configurable view"

^ true! !

!EMoeSeasideRoot class methodsFor: 'seaside' stamp: 'tpc 10/27/2008 17:02'!
description

	^ 'Alpha prototype Educational Math Module'! !

!EMoeSeasideRoot class methodsFor: 'seaside' stamp: 'tpc 10/23/2008 18:30'!
entryPointName
	^'emoe'! !

!EMoeSeasideRoot class methodsFor: 'class initialization' stamp: 'tpc 10/27/2008 17:02'!
initialize

		(self registerAsApplication: 'emoe')
		libraries add: SULibrary.
! !

!EMoeSeasideRoot methodsFor: 'initialization' stamp: 'tpc 10/30/2008 15:39'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	 super initialize.
	
	contents := WASimpleNavigation new.
	self register: contents.
	contents add: EMoeSeasideLDView new label: 'Long Division'.
	contents add: EMoeSeasideLDView new label: 'Fake Multiplication'.
! !

!EMoeSeasideRoot methodsFor: 'rendering' stamp: 'tpc 10/27/2008 17:15'!
renderContentOn: aRenderer
		"Render the tabs"
	aRenderer 
		heading: 'Math Module Examples';
		render: contents! !

!EMoeSeasideRoot methodsFor: 'accessing' stamp: 'tpc 10/27/2008 17:15'!
selectedComponent
	^contents selectedComponent! !

!EMoeSeasideRoot methodsFor: 'accessing' stamp: 'tpc 10/23/2008 18:34'!
title
 ^ 'EMoe Learning Center'! !

!EMoeSeasideRoot methodsFor: 'updating' stamp: 'tpc 10/23/2008 23:53'!
updateRoot: aRoot 
	| styles |
   	styles := WALinkElement new.
	styles beStylesheet; media: 'all'; url: 'http://sear.moedaworks.com/css/seaside/seastyle.css'.
	"styles beStylesheet; media: 'all'; url: 'http://localhost:8080/seaside/files/external/seastyle.css'."

	super updateRoot: aRoot.
   	aRoot	title: self title; add: styles.
		"addStyle: '/base.css';
		addStyle: '/public.css';
		addStyle: '/seastyle.css'."! !
EMoeSeasideRoot initialize!
